#property indicator_level1 0
#property indicator_separate_window
#property indicator_buffers 1        // not 2
#property indicator_color1 White

double Buf_0[];
  

// --- parameters
extern int history = 180;
extern bool log_on = false;
extern int MAperiod = 14;

string build=" ver 0.29g-TEST-MA";

bool isHistoryLoading;

int lastperiod=0;

int init()
  {

   isHistoryLoading = true;

   SetIndexStyle(0,DRAW_LINE,DRAW_SECTION,2);
   SetIndexBuffer(0,Buf_0);
   SetIndexLabel (0,"MA");   
   IndicatorShortName("MA ("+MAperiod+") "+build);
   SetLevelValue (0, 0.0000);       // The horizontal line level is set   

   return(0);
  }


int deinit()
  {
    return(0);
  }



int start()
   {
   
   double LARM=0 , ASB=0; 
   double O,C,H,L;
   datetime dt,mdt,dt1,dtTemp; 
   int  i, j, k, candles, counted_bars;
   double Buffer[10000];
   
   int LARMCandles;  // RaptorUK
   
   
   if (isHistoryLoading)
      {
      dt=iTime(Symbol(),PERIOD_M1,0); 
      if (dt == 0)
         {   
         isHistoryLoading = true;  
         return;
         }
         
      isHistoryLoading = false;
      counted_bars = 0;
      }
   else  
      counted_bars = IndicatorCounted();

   
   if (candles < 0) 
      return (0);   
   
   candles = Bars - counted_bars;                       // Index of the first uncounted
   if (candles > history - 1)                             // If too many bars ..
      {
      candles = history-1;                         // ..calculate specified amount
      }
     
   //********************************* MAIN WHILE LOOP ****************************                            
   
   if (candles < MAperiod) LARMCandles = MAperiod;  // RaptorUK
   else LARMCandles = candles;
   
   while ( i <= LARMCandles )
      {
//      Print("Candles = ", candles);
      
      L = Low[i];
      C = Close[i];
      LARM = LARM + C - L;                                 

      wlog("i change i["+i+"]");
               
      Buffer[i]= LARM; //store in a buffer for use in the second while loop

      i++;
                   
      LARM=0;         
          
      } 
      
   int vi=0;          
   double sum=0.0;
                         
   while ( vi <= candles) //CALCULATE MA
      {  
      vi++;
      for (int vk=vi; vk<vi+MAperiod; vk++)
         {
         sum=sum+Buffer[vk];
         }  //for
                                  
      sum=sum / MAperiod; 
      Buf_0[vi]= sum;//;   
      sum=0; 
      }//while

   return(0);
   } 

void wlog(string s)
   {
   if (log_on)
      {
      Print(s);
      }
   }  